<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>21.13. ftplib — FTP protocol client &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="21. Internet Protocols and Support" href="internet.html" />
    <link rel="next" title="21.14. poplib — POP3 protocol client" href="poplib.html" />
    <link rel="prev" title="21.12. http.client — HTTP protocol client" href="http.client.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="poplib.html" title="21.14. poplib — POP3 protocol client"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="http.client.html" title="21.12. http.client — HTTP protocol client"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" accesskey="U">21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-ftplib">
<span id="ftplib-ftp-protocol-client"></span><h1>21.13. <a class="reference internal" href="#module-ftplib" title="ftplib: FTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">ftplib</span></code></a> &#8212; FTP protocol client<a class="headerlink" href="#module-ftplib" title="Permalink to this headline">¶</a></h1>
<p id="index-0"><strong>Source code:</strong> <a class="reference external" href="https://hg.python.org/cpython/file/3.5/Lib/ftplib.py">Lib/ftplib.py</a></p>
<hr class="docutils" />
<p>This module defines the class <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> and a few related items. The
<a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> class implements the client side of the FTP protocol.  You can use
this to write Python programs that perform a variety of automated FTP jobs, such
as mirroring other ftp servers.  It is also used by the module
<a class="reference internal" href="urllib.request.html#module-urllib.request" title="urllib.request: Extensible library for opening URLs."><code class="xref py py-mod docutils literal"><span class="pre">urllib.request</span></code></a> to handle URLs that use FTP.  For more information on FTP
(File Transfer Protocol), see Internet <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc959.html"><strong>RFC 959</strong></a>.</p>
<p>Here&#8217;s a sample session using the <a class="reference internal" href="#module-ftplib" title="ftplib: FTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">ftplib</span></code></a> module:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">ftplib</span> <span class="k">import</span> <span class="n">FTP</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span> <span class="o">=</span> <span class="n">FTP</span><span class="p">(</span><span class="s">&#39;ftp.debian.org&#39;</span><span class="p">)</span>     <span class="c"># connect to host, default port</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span><span class="o">.</span><span class="n">login</span><span class="p">()</span>                     <span class="c"># user anonymous, passwd anonymous@</span>
<span class="go">&#39;230 Login successful.&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span><span class="o">.</span><span class="n">cwd</span><span class="p">(</span><span class="s">&#39;debian&#39;</span><span class="p">)</span>               <span class="c"># change into &quot;debian&quot; directory</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span><span class="o">.</span><span class="n">retrlines</span><span class="p">(</span><span class="s">&#39;LIST&#39;</span><span class="p">)</span>           <span class="c"># list directory contents</span>
<span class="go">-rw-rw-r--    1 1176     1176         1063 Jun 15 10:18 README</span>
<span class="gp">...</span>
<span class="go">drwxr-sr-x    5 1176     1176         4096 Dec 19  2000 pool</span>
<span class="go">drwxr-sr-x    4 1176     1176         4096 Nov 17  2008 project</span>
<span class="go">drwxr-xr-x    3 1176     1176         4096 Oct 10  2012 tools</span>
<span class="go">&#39;226 Directory send OK.&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span><span class="o">.</span><span class="n">retrbinary</span><span class="p">(</span><span class="s">&#39;RETR README&#39;</span><span class="p">,</span> <span class="nb">open</span><span class="p">(</span><span class="s">&#39;README&#39;</span><span class="p">,</span> <span class="s">&#39;wb&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">write</span><span class="p">)</span>
<span class="go">&#39;226 Transfer complete.&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftp</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
</pre></div>
</div>
<p>The module defines the following items:</p>
<dl class="class">
<dt id="ftplib.FTP">
<em class="property">class </em><code class="descclassname">ftplib.</code><code class="descname">FTP</code><span class="sig-paren">(</span><em>host=''</em>, <em>user=''</em>, <em>passwd=''</em>, <em>acct=''</em>, <em>timeout=None</em>, <em>source_address=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a new instance of the <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> class.  When <em>host</em> is given, the
method call <code class="docutils literal"><span class="pre">connect(host)</span></code> is made.  When <em>user</em> is given, additionally
the method call <code class="docutils literal"><span class="pre">login(user,</span> <span class="pre">passwd,</span> <span class="pre">acct)</span></code> is made (where <em>passwd</em> and
<em>acct</em> default to the empty string when not given).  The optional <em>timeout</em>
parameter specifies a timeout in seconds for blocking operations like the
connection attempt (if is not specified, the global default timeout setting
will be used). <em>source_address</em> is a 2-tuple <code class="docutils literal"><span class="pre">(host,</span> <span class="pre">port)</span></code> for the socket
to bind to as its source address before connecting.</p>
<p>The <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> class supports the <a class="reference internal" href="../reference/compound_stmts.html#with"><code class="xref std std-keyword docutils literal"><span class="pre">with</span></code></a> statement, e.g.:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">ftplib</span> <span class="k">import</span> <span class="n">FTP</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="n">FTP</span><span class="p">(</span><span class="s">&quot;ftp1.at.proftpd.org&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">ftp</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">ftp</span><span class="o">.</span><span class="n">login</span><span class="p">()</span>
<span class="gp">... </span>    <span class="n">ftp</span><span class="o">.</span><span class="n">dir</span><span class="p">()</span>
<span class="gp">...</span>
<span class="go">&#39;230 Anonymous login ok, restrictions apply.&#39;</span>
<span class="go">dr-xr-xr-x   9 ftp      ftp           154 May  6 10:43 .</span>
<span class="go">dr-xr-xr-x   9 ftp      ftp           154 May  6 10:43 ..</span>
<span class="go">dr-xr-xr-x   5 ftp      ftp          4096 May  6 10:43 CentOS</span>
<span class="go">dr-xr-xr-x   3 ftp      ftp            18 Jul 10  2008 Fedora</span>
<span class="go">&gt;&gt;&gt;</span>
</pre></div>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Support for the <a class="reference internal" href="../reference/compound_stmts.html#with"><code class="xref std std-keyword docutils literal"><span class="pre">with</span></code></a> statement was added.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span><em>source_address</em> parameter was added.</p>
</div>
</dd></dl>

<dl class="class">
<dt id="ftplib.FTP_TLS">
<em class="property">class </em><code class="descclassname">ftplib.</code><code class="descname">FTP_TLS</code><span class="sig-paren">(</span><em>host=''</em>, <em>user=''</em>, <em>passwd=''</em>, <em>acct=''</em>, <em>keyfile=None</em>, <em>certfile=None</em>, <em>context=None</em>, <em>timeout=None</em>, <em>source_address=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP_TLS" title="Permalink to this definition">¶</a></dt>
<dd><p>A <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> subclass which adds TLS support to FTP as described in
<span class="target" id="index-2"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4217.html"><strong>RFC 4217</strong></a>.
Connect as usual to port 21 implicitly securing the FTP control connection
before authenticating. Securing the data connection requires the user to
explicitly ask for it by calling the <a class="reference internal" href="#ftplib.FTP_TLS.prot_p" title="ftplib.FTP_TLS.prot_p"><code class="xref py py-meth docutils literal"><span class="pre">prot_p()</span></code></a> method.  <em>context</em>
is a <a class="reference internal" href="ssl.html#ssl.SSLContext" title="ssl.SSLContext"><code class="xref py py-class docutils literal"><span class="pre">ssl.SSLContext</span></code></a> object which allows bundling SSL configuration
options, certificates and private keys into a single (potentially
long-lived) structure.  Please read <a class="reference internal" href="ssl.html#ssl-security"><span>Security considerations</span></a> for best practices.</p>
<p><em>keyfile</em> and <em>certfile</em> are a legacy alternative to <em>context</em> &#8211; they
can point to PEM-formatted private key and certificate chain files
(respectively) for the SSL connection.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span><em>source_address</em> parameter was added.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The class now supports hostname check with
<a class="reference internal" href="ssl.html#ssl.SSLContext.check_hostname" title="ssl.SSLContext.check_hostname"><code class="xref py py-attr docutils literal"><span class="pre">ssl.SSLContext.check_hostname</span></code></a> and <em>Server Name Indication</em> (see
<a class="reference internal" href="ssl.html#ssl.HAS_SNI" title="ssl.HAS_SNI"><code class="xref py py-data docutils literal"><span class="pre">ssl.HAS_SNI</span></code></a>).</p>
</div>
<p>Here&#8217;s a sample session using the <a class="reference internal" href="#ftplib.FTP_TLS" title="ftplib.FTP_TLS"><code class="xref py py-class docutils literal"><span class="pre">FTP_TLS</span></code></a> class:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">ftps</span> <span class="o">=</span> <span class="n">FTP_TLS</span><span class="p">(</span><span class="s">&#39;ftp.pureftpd.org&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftps</span><span class="o">.</span><span class="n">login</span><span class="p">()</span>
<span class="go">&#39;230 Anonymous user logged in&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftps</span><span class="o">.</span><span class="n">prot_p</span><span class="p">()</span>
<span class="go">&#39;200 Data protection level set to &quot;private&quot;&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ftps</span><span class="o">.</span><span class="n">nlst</span><span class="p">()</span>
<span class="go">[&#39;6jack&#39;, &#39;OpenBSD&#39;, &#39;antilink&#39;, &#39;blogbench&#39;, &#39;bsdcam&#39;, &#39;clockspeed&#39;, &#39;djbdns-jedi&#39;, &#39;docs&#39;, &#39;eaccelerator-jedi&#39;, &#39;favicon.ico&#39;, &#39;francotone&#39;, &#39;fugu&#39;, &#39;ignore&#39;, &#39;libpuzzle&#39;, &#39;metalog&#39;, &#39;minidentd&#39;, &#39;misc&#39;, &#39;mysql-udf-global-user-variables&#39;, &#39;php-jenkins-hash&#39;, &#39;php-skein-hash&#39;, &#39;php-webdav&#39;, &#39;phpaudit&#39;, &#39;phpbench&#39;, &#39;pincaster&#39;, &#39;ping&#39;, &#39;posto&#39;, &#39;pub&#39;, &#39;public&#39;, &#39;public_keys&#39;, &#39;pure-ftpd&#39;, &#39;qscan&#39;, &#39;qtc&#39;, &#39;sharedance&#39;, &#39;skycache&#39;, &#39;sound&#39;, &#39;tmp&#39;, &#39;ucarp&#39;]</span>
</pre></div>
</div>
</dd></dl>

<dl class="exception">
<dt id="ftplib.error_reply">
<em class="property">exception </em><code class="descclassname">ftplib.</code><code class="descname">error_reply</code><a class="headerlink" href="#ftplib.error_reply" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception raised when an unexpected reply is received from the server.</p>
</dd></dl>

<dl class="exception">
<dt id="ftplib.error_temp">
<em class="property">exception </em><code class="descclassname">ftplib.</code><code class="descname">error_temp</code><a class="headerlink" href="#ftplib.error_temp" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception raised when an error code signifying a temporary error (response
codes in the range 400&#8211;499) is received.</p>
</dd></dl>

<dl class="exception">
<dt id="ftplib.error_perm">
<em class="property">exception </em><code class="descclassname">ftplib.</code><code class="descname">error_perm</code><a class="headerlink" href="#ftplib.error_perm" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception raised when an error code signifying a permanent error (response
codes in the range 500&#8211;599) is received.</p>
</dd></dl>

<dl class="exception">
<dt id="ftplib.error_proto">
<em class="property">exception </em><code class="descclassname">ftplib.</code><code class="descname">error_proto</code><a class="headerlink" href="#ftplib.error_proto" title="Permalink to this definition">¶</a></dt>
<dd><p>Exception raised when a reply is received from the server that does not fit
the response specifications of the File Transfer Protocol, i.e. begin with a
digit in the range 1&#8211;5.</p>
</dd></dl>

<dl class="data">
<dt id="ftplib.all_errors">
<code class="descclassname">ftplib.</code><code class="descname">all_errors</code><a class="headerlink" href="#ftplib.all_errors" title="Permalink to this definition">¶</a></dt>
<dd><p>The set of all exceptions (as a tuple) that methods of <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a>
instances may raise as a result of problems with the FTP connection (as
opposed to programming errors made by the caller).  This set includes the
four exceptions listed above as well as <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a>.</p>
</dd></dl>

<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="docutils">
<dt>Module <a class="reference internal" href="netrc.html#module-netrc" title="netrc: Loading of .netrc files."><code class="xref py py-mod docutils literal"><span class="pre">netrc</span></code></a></dt>
<dd>Parser for the <code class="file docutils literal"><span class="pre">.netrc</span></code> file format.  The file <code class="file docutils literal"><span class="pre">.netrc</span></code> is
typically used by FTP clients to load user authentication information
before prompting the user.</dd>
</dl>
<p class="last" id="index-3">The file <code class="file docutils literal"><span class="pre">Tools/scripts/ftpmirror.py</span></code> in the Python source distribution is
a script that can mirror FTP sites, or portions thereof, using the <a class="reference internal" href="#module-ftplib" title="ftplib: FTP protocol client (requires sockets)."><code class="xref py py-mod docutils literal"><span class="pre">ftplib</span></code></a>
module. It can be used as an extended example that applies this module.</p>
</div>
<div class="section" id="ftp-objects">
<span id="id1"></span><h2>21.13.1. FTP Objects<a class="headerlink" href="#ftp-objects" title="Permalink to this headline">¶</a></h2>
<p>Several methods are available in two flavors: one for handling text files and
another for binary files.  These are named for the command which is used
followed by <code class="docutils literal"><span class="pre">lines</span></code> for the text version or <code class="docutils literal"><span class="pre">binary</span></code> for the binary version.</p>
<p><a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> instances have the following methods:</p>
<dl class="method">
<dt id="ftplib.FTP.set_debuglevel">
<code class="descclassname">FTP.</code><code class="descname">set_debuglevel</code><span class="sig-paren">(</span><em>level</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.set_debuglevel" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the instance&#8217;s debugging level.  This controls the amount of debugging
output printed.  The default, <code class="docutils literal"><span class="pre">0</span></code>, produces no debugging output.  A value of
<code class="docutils literal"><span class="pre">1</span></code> produces a moderate amount of debugging output, generally a single line
per request.  A value of <code class="docutils literal"><span class="pre">2</span></code> or higher produces the maximum amount of
debugging output, logging each line sent and received on the control connection.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.connect">
<code class="descclassname">FTP.</code><code class="descname">connect</code><span class="sig-paren">(</span><em>host=''</em>, <em>port=0</em>, <em>timeout=None</em>, <em>source_address=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.connect" title="Permalink to this definition">¶</a></dt>
<dd><p>Connect to the given host and port.  The default port number is <code class="docutils literal"><span class="pre">21</span></code>, as
specified by the FTP protocol specification.  It is rarely needed to specify a
different port number.  This function should be called only once for each
instance; it should not be called at all if a host was given when the instance
was created.  All other methods can only be used after a connection has been
made.
The optional <em>timeout</em> parameter specifies a timeout in seconds for the
connection attempt. If no <em>timeout</em> is passed, the global default timeout
setting will be used.
<em>source_address</em> is a 2-tuple <code class="docutils literal"><span class="pre">(host,</span> <span class="pre">port)</span></code> for the socket to bind to as
its source address before connecting.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span><em>source_address</em> parameter was added.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.getwelcome">
<code class="descclassname">FTP.</code><code class="descname">getwelcome</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.getwelcome" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the welcome message sent by the server in reply to the initial
connection.  (This message sometimes contains disclaimers or help information
that may be relevant to the user.)</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.login">
<code class="descclassname">FTP.</code><code class="descname">login</code><span class="sig-paren">(</span><em>user='anonymous'</em>, <em>passwd=''</em>, <em>acct=''</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.login" title="Permalink to this definition">¶</a></dt>
<dd><p>Log in as the given <em>user</em>.  The <em>passwd</em> and <em>acct</em> parameters are optional and
default to the empty string.  If no <em>user</em> is specified, it defaults to
<code class="docutils literal"><span class="pre">'anonymous'</span></code>.  If <em>user</em> is <code class="docutils literal"><span class="pre">'anonymous'</span></code>, the default <em>passwd</em> is
<code class="docutils literal"><span class="pre">'anonymous&#64;'</span></code>.  This function should be called only once for each instance,
after a connection has been established; it should not be called at all if a
host and user were given when the instance was created.  Most FTP commands are
only allowed after the client has logged in.  The <em>acct</em> parameter supplies
&#8220;accounting information&#8221;; few systems implement this.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.abort">
<code class="descclassname">FTP.</code><code class="descname">abort</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.abort" title="Permalink to this definition">¶</a></dt>
<dd><p>Abort a file transfer that is in progress.  Using this does not always work, but
it&#8217;s worth a try.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.sendcmd">
<code class="descclassname">FTP.</code><code class="descname">sendcmd</code><span class="sig-paren">(</span><em>cmd</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.sendcmd" title="Permalink to this definition">¶</a></dt>
<dd><p>Send a simple command string to the server and return the response string.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.voidcmd">
<code class="descclassname">FTP.</code><code class="descname">voidcmd</code><span class="sig-paren">(</span><em>cmd</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.voidcmd" title="Permalink to this definition">¶</a></dt>
<dd><p>Send a simple command string to the server and handle the response.  Return
nothing if a response code corresponding to success (codes in the range
200&#8211;299) is received.  Raise <a class="reference internal" href="#ftplib.error_reply" title="ftplib.error_reply"><code class="xref py py-exc docutils literal"><span class="pre">error_reply</span></code></a> otherwise.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.retrbinary">
<code class="descclassname">FTP.</code><code class="descname">retrbinary</code><span class="sig-paren">(</span><em>cmd</em>, <em>callback</em>, <em>blocksize=8192</em>, <em>rest=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.retrbinary" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieve a file in binary transfer mode.  <em>cmd</em> should be an appropriate
<code class="docutils literal"><span class="pre">RETR</span></code> command: <code class="docutils literal"><span class="pre">'RETR</span> <span class="pre">filename'</span></code>. The <em>callback</em> function is called for
each block of data received, with a single string argument giving the data
block. The optional <em>blocksize</em> argument specifies the maximum chunk size to
read on the low-level socket object created to do the actual transfer (which
will also be the largest size of the data blocks passed to <em>callback</em>).  A
reasonable default is chosen. <em>rest</em> means the same thing as in the
<a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a> method.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.retrlines">
<code class="descclassname">FTP.</code><code class="descname">retrlines</code><span class="sig-paren">(</span><em>cmd</em>, <em>callback=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.retrlines" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieve a file or directory listing in ASCII transfer mode.  <em>cmd</em> should be
an appropriate <code class="docutils literal"><span class="pre">RETR</span></code> command (see <a class="reference internal" href="#ftplib.FTP.retrbinary" title="ftplib.FTP.retrbinary"><code class="xref py py-meth docutils literal"><span class="pre">retrbinary()</span></code></a>) or a command such as
<code class="docutils literal"><span class="pre">LIST</span></code> or <code class="docutils literal"><span class="pre">NLST</span></code> (usually just the string <code class="docutils literal"><span class="pre">'LIST'</span></code>).
<code class="docutils literal"><span class="pre">LIST</span></code> retrieves a list of files and information about those files.
<code class="docutils literal"><span class="pre">NLST</span></code> retrieves a list of file names.
The <em>callback</em> function is called for each line with a string argument
containing the line with the trailing CRLF stripped.  The default <em>callback</em>
prints the line to <code class="docutils literal"><span class="pre">sys.stdout</span></code>.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.set_pasv">
<code class="descclassname">FTP.</code><code class="descname">set_pasv</code><span class="sig-paren">(</span><em>boolean</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.set_pasv" title="Permalink to this definition">¶</a></dt>
<dd><p>Enable &#8220;passive&#8221; mode if <em>boolean</em> is true, other disable passive mode.
Passive mode is on by default.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.storbinary">
<code class="descclassname">FTP.</code><code class="descname">storbinary</code><span class="sig-paren">(</span><em>cmd</em>, <em>fp</em>, <em>blocksize=8192</em>, <em>callback=None</em>, <em>rest=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.storbinary" title="Permalink to this definition">¶</a></dt>
<dd><p>Store a file in binary transfer mode.  <em>cmd</em> should be an appropriate
<code class="docutils literal"><span class="pre">STOR</span></code> command: <code class="docutils literal"><span class="pre">&quot;STOR</span> <span class="pre">filename&quot;</span></code>. <em>fp</em> is a <a class="reference internal" href="../glossary.html#term-file-object"><span class="xref std std-term">file object</span></a>
(opened in binary mode) which is read until EOF using its <code class="xref py py-meth docutils literal"><span class="pre">read()</span></code>
method in blocks of size <em>blocksize</em> to provide the data to be stored.
The <em>blocksize</em> argument defaults to 8192.  <em>callback</em> is an optional single
parameter callable that is called on each block of data after it is sent.
<em>rest</em> means the same thing as in the <a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a> method.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span><em>rest</em> parameter added.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.storlines">
<code class="descclassname">FTP.</code><code class="descname">storlines</code><span class="sig-paren">(</span><em>cmd</em>, <em>fp</em>, <em>callback=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.storlines" title="Permalink to this definition">¶</a></dt>
<dd><p>Store a file in ASCII transfer mode.  <em>cmd</em> should be an appropriate
<code class="docutils literal"><span class="pre">STOR</span></code> command (see <a class="reference internal" href="#ftplib.FTP.storbinary" title="ftplib.FTP.storbinary"><code class="xref py py-meth docutils literal"><span class="pre">storbinary()</span></code></a>).  Lines are read until EOF from the
<a class="reference internal" href="../glossary.html#term-file-object"><span class="xref std std-term">file object</span></a> <em>fp</em> (opened in binary mode) using its <a class="reference internal" href="io.html#io.IOBase.readline" title="io.IOBase.readline"><code class="xref py py-meth docutils literal"><span class="pre">readline()</span></code></a>
method to provide the data to be stored.  <em>callback</em> is an optional single
parameter callable that is called on each line after it is sent.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.transfercmd">
<code class="descclassname">FTP.</code><code class="descname">transfercmd</code><span class="sig-paren">(</span><em>cmd</em>, <em>rest=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.transfercmd" title="Permalink to this definition">¶</a></dt>
<dd><p>Initiate a transfer over the data connection.  If the transfer is active, send an
<code class="docutils literal"><span class="pre">EPRT</span></code> or  <code class="docutils literal"><span class="pre">PORT</span></code> command and the transfer command specified by <em>cmd</em>, and
accept the connection.  If the server is passive, send an <code class="docutils literal"><span class="pre">EPSV</span></code> or <code class="docutils literal"><span class="pre">PASV</span></code>
command, connect to it, and start the transfer command.  Either way, return the
socket for the connection.</p>
<p>If optional <em>rest</em> is given, a <code class="docutils literal"><span class="pre">REST</span></code> command is sent to the server, passing
<em>rest</em> as an argument.  <em>rest</em> is usually a byte offset into the requested file,
telling the server to restart sending the file&#8217;s bytes at the requested offset,
skipping over the initial bytes.  Note however that RFC 959 requires only that
<em>rest</em> be a string containing characters in the printable range from ASCII code
33 to ASCII code 126.  The <a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a> method, therefore, converts
<em>rest</em> to a string, but no check is performed on the string&#8217;s contents.  If the
server does not recognize the <code class="docutils literal"><span class="pre">REST</span></code> command, an <a class="reference internal" href="#ftplib.error_reply" title="ftplib.error_reply"><code class="xref py py-exc docutils literal"><span class="pre">error_reply</span></code></a> exception
will be raised.  If this happens, simply call <a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a> without a
<em>rest</em> argument.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.ntransfercmd">
<code class="descclassname">FTP.</code><code class="descname">ntransfercmd</code><span class="sig-paren">(</span><em>cmd</em>, <em>rest=None</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.ntransfercmd" title="Permalink to this definition">¶</a></dt>
<dd><p>Like <a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a>, but returns a tuple of the data connection and the
expected size of the data.  If the expected size could not be computed, <code class="docutils literal"><span class="pre">None</span></code>
will be returned as the expected size.  <em>cmd</em> and <em>rest</em> means the same thing as
in <a class="reference internal" href="#ftplib.FTP.transfercmd" title="ftplib.FTP.transfercmd"><code class="xref py py-meth docutils literal"><span class="pre">transfercmd()</span></code></a>.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.mlsd">
<code class="descclassname">FTP.</code><code class="descname">mlsd</code><span class="sig-paren">(</span><em>path=&quot;&quot;</em>, <em>facts=[]</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.mlsd" title="Permalink to this definition">¶</a></dt>
<dd><p>List a directory in a standardized format by using <code class="docutils literal"><span class="pre">MLSD</span></code> command
(<span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc3659.html"><strong>RFC 3659</strong></a>).  If <em>path</em> is omitted the current directory is assumed.
<em>facts</em> is a list of strings representing the type of information desired
(e.g. <code class="docutils literal"><span class="pre">[&quot;type&quot;,</span> <span class="pre">&quot;size&quot;,</span> <span class="pre">&quot;perm&quot;]</span></code>).  Return a generator object yielding a
tuple of two elements for every file found in path.  First element is the
file name, the second one is a dictionary containing facts about the file
name.  Content of this dictionary might be limited by the <em>facts</em> argument
but server is not guaranteed to return all requested facts.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.nlst">
<code class="descclassname">FTP.</code><code class="descname">nlst</code><span class="sig-paren">(</span><em>argument</em><span class="optional">[</span>, <em>...</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.nlst" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a list of file names as returned by the <code class="docutils literal"><span class="pre">NLST</span></code> command.  The
optional <em>argument</em> is a directory to list (default is the current server
directory).  Multiple arguments can be used to pass non-standard options to
the <code class="docutils literal"><span class="pre">NLST</span></code> command.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If your server supports the command, <a class="reference internal" href="#ftplib.FTP.mlsd" title="ftplib.FTP.mlsd"><code class="xref py py-meth docutils literal"><span class="pre">mlsd()</span></code></a> offers a better API.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.dir">
<code class="descclassname">FTP.</code><code class="descname">dir</code><span class="sig-paren">(</span><em>argument</em><span class="optional">[</span>, <em>...</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.dir" title="Permalink to this definition">¶</a></dt>
<dd><p>Produce a directory listing as returned by the <code class="docutils literal"><span class="pre">LIST</span></code> command, printing it to
standard output.  The optional <em>argument</em> is a directory to list (default is the
current server directory).  Multiple arguments can be used to pass non-standard
options to the <code class="docutils literal"><span class="pre">LIST</span></code> command.  If the last argument is a function, it is used
as a <em>callback</em> function as for <a class="reference internal" href="#ftplib.FTP.retrlines" title="ftplib.FTP.retrlines"><code class="xref py py-meth docutils literal"><span class="pre">retrlines()</span></code></a>; the default prints to
<code class="docutils literal"><span class="pre">sys.stdout</span></code>.  This method returns <code class="docutils literal"><span class="pre">None</span></code>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">If your server supports the command, <a class="reference internal" href="#ftplib.FTP.mlsd" title="ftplib.FTP.mlsd"><code class="xref py py-meth docutils literal"><span class="pre">mlsd()</span></code></a> offers a better API.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.rename">
<code class="descclassname">FTP.</code><code class="descname">rename</code><span class="sig-paren">(</span><em>fromname</em>, <em>toname</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.rename" title="Permalink to this definition">¶</a></dt>
<dd><p>Rename file <em>fromname</em> on the server to <em>toname</em>.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.delete">
<code class="descclassname">FTP.</code><code class="descname">delete</code><span class="sig-paren">(</span><em>filename</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.delete" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove the file named <em>filename</em> from the server.  If successful, returns the
text of the response, otherwise raises <a class="reference internal" href="#ftplib.error_perm" title="ftplib.error_perm"><code class="xref py py-exc docutils literal"><span class="pre">error_perm</span></code></a> on permission errors or
<a class="reference internal" href="#ftplib.error_reply" title="ftplib.error_reply"><code class="xref py py-exc docutils literal"><span class="pre">error_reply</span></code></a> on other errors.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.cwd">
<code class="descclassname">FTP.</code><code class="descname">cwd</code><span class="sig-paren">(</span><em>pathname</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.cwd" title="Permalink to this definition">¶</a></dt>
<dd><p>Set the current directory on the server.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.mkd">
<code class="descclassname">FTP.</code><code class="descname">mkd</code><span class="sig-paren">(</span><em>pathname</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.mkd" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a new directory on the server.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.pwd">
<code class="descclassname">FTP.</code><code class="descname">pwd</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.pwd" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the pathname of the current directory on the server.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.rmd">
<code class="descclassname">FTP.</code><code class="descname">rmd</code><span class="sig-paren">(</span><em>dirname</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.rmd" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove the directory named <em>dirname</em> on the server.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.size">
<code class="descclassname">FTP.</code><code class="descname">size</code><span class="sig-paren">(</span><em>filename</em><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.size" title="Permalink to this definition">¶</a></dt>
<dd><p>Request the size of the file named <em>filename</em> on the server.  On success, the
size of the file is returned as an integer, otherwise <code class="docutils literal"><span class="pre">None</span></code> is returned.
Note that the <code class="docutils literal"><span class="pre">SIZE</span></code> command is not  standardized, but is supported by many
common server implementations.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.quit">
<code class="descclassname">FTP.</code><code class="descname">quit</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.quit" title="Permalink to this definition">¶</a></dt>
<dd><p>Send a <code class="docutils literal"><span class="pre">QUIT</span></code> command to the server and close the connection. This is the
&#8220;polite&#8221; way to close a connection, but it may raise an exception if the server
responds with an error to the <code class="docutils literal"><span class="pre">QUIT</span></code> command.  This implies a call to the
<a class="reference internal" href="#ftplib.FTP.close" title="ftplib.FTP.close"><code class="xref py py-meth docutils literal"><span class="pre">close()</span></code></a> method which renders the <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> instance useless for
subsequent calls (see below).</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP.close">
<code class="descclassname">FTP.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the connection unilaterally.  This should not be applied to an already
closed connection such as after a successful call to <a class="reference internal" href="#ftplib.FTP.quit" title="ftplib.FTP.quit"><code class="xref py py-meth docutils literal"><span class="pre">quit()</span></code></a>.
After this call the <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a> instance should not be used any more (after
a call to <a class="reference internal" href="#ftplib.FTP.close" title="ftplib.FTP.close"><code class="xref py py-meth docutils literal"><span class="pre">close()</span></code></a> or <a class="reference internal" href="#ftplib.FTP.quit" title="ftplib.FTP.quit"><code class="xref py py-meth docutils literal"><span class="pre">quit()</span></code></a> you cannot reopen the
connection by issuing another <a class="reference internal" href="#ftplib.FTP.login" title="ftplib.FTP.login"><code class="xref py py-meth docutils literal"><span class="pre">login()</span></code></a> method).</p>
</dd></dl>

</div>
<div class="section" id="ftp-tls-objects">
<h2>21.13.2. FTP_TLS Objects<a class="headerlink" href="#ftp-tls-objects" title="Permalink to this headline">¶</a></h2>
<p><a class="reference internal" href="#ftplib.FTP_TLS" title="ftplib.FTP_TLS"><code class="xref py py-class docutils literal"><span class="pre">FTP_TLS</span></code></a> class inherits from <a class="reference internal" href="#ftplib.FTP" title="ftplib.FTP"><code class="xref py py-class docutils literal"><span class="pre">FTP</span></code></a>, defining these additional objects:</p>
<dl class="attribute">
<dt id="ftplib.FTP_TLS.ssl_version">
<code class="descclassname">FTP_TLS.</code><code class="descname">ssl_version</code><a class="headerlink" href="#ftplib.FTP_TLS.ssl_version" title="Permalink to this definition">¶</a></dt>
<dd><p>The SSL version to use (defaults to <a class="reference internal" href="ssl.html#ssl.PROTOCOL_SSLv23" title="ssl.PROTOCOL_SSLv23"><code class="xref py py-attr docutils literal"><span class="pre">ssl.PROTOCOL_SSLv23</span></code></a>).</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP_TLS.auth">
<code class="descclassname">FTP_TLS.</code><code class="descname">auth</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP_TLS.auth" title="Permalink to this definition">¶</a></dt>
<dd><p>Set up a secure control connection by using TLS or SSL, depending on what
is specified in the <a class="reference internal" href="#ftplib.FTP_TLS.ssl_version" title="ftplib.FTP_TLS.ssl_version"><code class="xref py py-attr docutils literal"><span class="pre">ssl_version</span></code></a> attribute.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The method now supports hostname check with
<a class="reference internal" href="ssl.html#ssl.SSLContext.check_hostname" title="ssl.SSLContext.check_hostname"><code class="xref py py-attr docutils literal"><span class="pre">ssl.SSLContext.check_hostname</span></code></a> and <em>Server Name Indication</em> (see
<a class="reference internal" href="ssl.html#ssl.HAS_SNI" title="ssl.HAS_SNI"><code class="xref py py-data docutils literal"><span class="pre">ssl.HAS_SNI</span></code></a>).</p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP_TLS.ccc">
<code class="descclassname">FTP_TLS.</code><code class="descname">ccc</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP_TLS.ccc" title="Permalink to this definition">¶</a></dt>
<dd><p>Revert control channel back to plaintext.  This can be useful to take
advantage of firewalls that know how to handle NAT with non-secure FTP
without opening fixed ports.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP_TLS.prot_p">
<code class="descclassname">FTP_TLS.</code><code class="descname">prot_p</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP_TLS.prot_p" title="Permalink to this definition">¶</a></dt>
<dd><p>Set up secure data connection.</p>
</dd></dl>

<dl class="method">
<dt id="ftplib.FTP_TLS.prot_c">
<code class="descclassname">FTP_TLS.</code><code class="descname">prot_c</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#ftplib.FTP_TLS.prot_c" title="Permalink to this definition">¶</a></dt>
<dd><p>Set up clear text data connection.</p>
</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">21.13. <code class="docutils literal"><span class="pre">ftplib</span></code> &#8212; FTP protocol client</a><ul>
<li><a class="reference internal" href="#ftp-objects">21.13.1. FTP Objects</a></li>
<li><a class="reference internal" href="#ftp-tls-objects">21.13.2. FTP_TLS Objects</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="http.client.html"
                        title="previous chapter">21.12. <code class="docutils literal"><span class="pre">http.client</span></code> &#8212; HTTP protocol client</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="poplib.html"
                        title="next chapter">21.14. <code class="docutils literal"><span class="pre">poplib</span></code> &#8212; POP3 protocol client</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/ftplib.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="poplib.html" title="21.14. poplib — POP3 protocol client"
             >next</a> |</li>
        <li class="right" >
          <a href="http.client.html" title="21.12. http.client — HTTP protocol client"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="internet.html" >21. Internet Protocols and Support</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>